Unit SBPMixer;
InterFace
Procedure MixerReset;
Function MixerStatus : Byte;
Procedure MixerSetDACLevel(Left,Right : Byte);
Function MixerGetDACLevel : Byte;
Procedure MixerSetMicrophoneLevel(Level : Byte);
Function MixerGetMicrophoneLevel : Byte;
Procedure MixerSetMasterLevel(Left,Right : Byte);
Function MixerGetMasterLevel : Byte;
Procedure MixerSetFMLevel(Left,Right : Byte);
Function MixerGetFMLevel : Byte;
Procedure MixerSetCDAudioLevel(Left,Right : Byte);
Function MixerGetCDAudioLevel : Byte;
Procedure MixerSetLineInLevel(Left,Right : Byte);
Function MixerGetLineInLevel : Byte;
Implementation
Uses Crt;
Const
 BaseAddress : Word = $220; {    220h - Base  330h - Midi }
 MixerPort : Word = $224; { BaseAddress + 04h }
{   㭪樨  ࠡ  稯  }
Procedure SetIndexDataPort(PortN : Word; Index,Data : Byte);
Begin
 Port[PortN]:=Index;
 Port[PortN+1]:=Data;
End;
Function GetIndexDataPort(PortN : Word; Index : Byte): Byte;
Begin
 Port[PortN]:=Index;
 GetIndexDataPort:=Port[PortN+1];
End;
{  㭪権  ࠢ ஬ }
{   000h - Reset : 뢠   砫쭮  }
{ ⮫쪮 , 祭 0000000x  }
{ १ࢨ஢  Reset Status (0 - Stop reset) }
Procedure MixerReset;
Begin
 SetIndexDataPort(MixerPort,$00,$01);
 Delay(100);
 SetIndexDataPort(MixerPort,$00,$00);
End;
{   001h - Status : ⮫쪮 ⥭. 頥   SB }
Function MixerStatus : Byte;
Begin
 MixerStatus:=GetIndexDataPort(MixerPort,$01);
End;
{   004h - DACLevel : ⥭/. 㫨 DAC () SB }
{		 祭 00010001  }
{    ٳ 1 - SBPro, 0 - SB16 }
{			     	 ࠢ   }
{			      1 - SBPro, 0 - SB16 }
Procedure MixerSetDACLevel(Left,Right : Byte);
Begin
 SetIndexDataPort(MixerPort,$04,((((Left SHL 4) OR Right) SHL 1) OR $11));
End;
Function MixerGetDACLevel : Byte;
Begin
 MixerGetDACLevel:=GetIndexDataPort(MixerPort,$04);
End;
{   00Ah - MicrophoneLevel : ⥭/. 㫨 DAC () SB }
{		 祭 00000000  }
{ १ࢨ஢ ٳ 0 - SBPro, 1 - SB16 }
{			        Microphone Level (SBPro) }
Procedure MixerSetMicrophoneLevel(Level : Byte);
Begin
 SetIndexDataPort(MixerPort,$0A,Level SHL 1);
End;
Function MixerGetMicrophoneLevel : Byte;
Begin
 MixerGetMicrophoneLevel:=GetIndexDataPort(MixerPort,$0A);
End;
{   022h - Master volume : ⥭/. }
{		 祭 00010001  }
{   Master ٳ 1 - SBPro, 0 - SB16 }
{			     	 ࠢ  Master }
{			      1 - SBPro, 0 - SB16 }
Procedure MixerSetMasterLevel(Left,Right : Byte);
Begin
 SetIndexDataPort(MixerPort,$22,((((Left SHL 4) OR Right) SHL 1) OR $11));
End;
Function MixerGetMasterLevel : Byte;
Begin
 MixerGetMasterLevel:=GetIndexDataPort(MixerPort,$22);
End;
{   026h - FM volume : ⥭/. }
{		 祭 00010001  }
{   FM ٳ 1 - SBPro, 0 - SB16 }
{			     	 ࠢ  FM }
{			      1 - SBPro, 0 - SB16 }
Procedure MixerSetFMLevel(Left,Right : Byte);
Begin
 SetIndexDataPort(MixerPort,$26,((((Left SHL 4) OR Right) SHL 1) OR $11));
End;
Function MixerGetFMLevel : Byte;
Begin
 MixerGetFMLevel:=GetIndexDataPort(MixerPort,$26);
End;
{   028h - CD Audio Level : ⥭/. }
{		 祭 00010001  }
{   CD Audio ٳ 1 - SBPro, 0 - SB16 }
{			     	 ࠢ  CD Audio }
{			      1 - SBPro, 0 - SB16 }
Procedure MixerSetCDAudioLevel(Left,Right : Byte);
Begin
 SetIndexDataPort(MixerPort,$28,((((Left SHL 4) OR Right) SHL 1) OR $11));
End;
Function MixerGetCDAudioLevel : Byte;
Begin
 MixerGetCDAudioLevel:=GetIndexDataPort(MixerPort,$28);
End;
{   02Eh - Line In Level : ⥭/. }
{		 祭 00010001  }
{   Line In ٳ 1 - SBPro, 0 - SB16 }
{			     	 ࠢ  Line In }
{			      1 - SBPro, 0 - SB16 }
Procedure MixerSetLineInLevel(Left,Right : Byte);
Begin
 SetIndexDataPort(MixerPort,$2E,((((Left SHL 4) OR Right) SHL 1) OR $11));
End;
Function MixerGetLineInLevel : Byte;
Begin
 MixerGetLineInLevel:=GetIndexDataPort(MixerPort,$2E);
End;
End.